<template>
    <div>
        <div class="caption">
            Action Figures Sales Record
        </div>  
        <!-- Dropdown for changing values -->
        <div class="q-mr-lg q-mt-lg float-right">
            <q-select v-model="chartType" :options="chartTypeOptions" label="Select Type" class="inputSize" />
            <q-select v-model="selectedData" :options="options" label="Select data" class="inputSize" />
            <q-input v-model="newQuantity" label="Quantity" class="inputSize"/><br><br>
            <q-input v-model="newData" label="New Data" class="inputSize"/>
            <q-btn color="white" text-color="black" label="Add" @click="addNew" class="q-mt-sm"/>
        </div>

    
        <div class="chartSize">       
            <IEcharts :option='updateData.chartOption' :resizable="true" />
        </div>
    </div>
</template>

<script>
  import IEcharts from 'vue-echarts-v3/src/full.js';
  export default {
    name: 'Charts',
    components: {
        IEcharts
    },
    computed: {
        updateData: function(){
            return{
                chartOption: {
                legend: {},
                tooltip: {},
                series: [
                    {
                        type: this.changeChartType,
                        data: this.updateValue,
                        color: ['rgba(255,159,64,0.6)', 'rgba(153,102,255,0.6)', 'rgba(75,192,192,0.6)', 'rgba(255,206,86,0.6)', 'rgba(54,162,235,0.6)', 'rgba(255,99,132,0.6)'],

                    }
                ],
                xAxis: {
                    type: 'category',
                    data: this.xAxisData
                },
                yAxis: [{
                    type: 'value'
                }]
            }
                
            }
        },

        updateValue: function(){
            let dataIndex = this.xAxisData.indexOf(this.selectedData)
            this.seriesData[dataIndex] = this.newQuantity
            return this.seriesData
        },

        changeChartType: function(){
            this.chartOption.series[0].type = this.chartType
            return this.chartOption.series[0].type
        }

    },
    data() {
        return {
            options: ['Captain America', 'Ironman', 'Thor', 'Loki', 'Gamora', 'Groot'],
            newQuantity: '',
            selectedData: '',
            newData: '',
            seriesData: [25000, 16000, 23500, 29500, 20000, 26700],
            xAxisData: ['Captain America', 'Ironman', 'Thor', 'Loki', 'Gamora', 'Groot'],

            chartTypeOptions: ['bar', 'line', 'scatter'],
            chartType: 'bar',

            chartOption: {
                legend: {},
                tooltip: {},
                series: [
                    {
                        type: 'bar',
                        data: this.seriesData,
                        color: ['rgba(255,99,132,0.6)', 'rgba(54,162,235,0.6)', 'rgba(255,206,86,0.6)', 'rgba(75,192,192,0.6)', 'rgba(153,102,255,0.6)', 'rgba(255,159,64,0.6)'],

                    }
                ],
                xAxis: {
                    type: 'category',
                    data: this.xAxisData
                },
                yAxis: [{
                    type: 'value'
                }]
            }
            
        }
    },

    methods: {
        addNew() {
            if(this.newData==='')
            {    
                alert('Empty data')
                return
            }
            this.xAxisData.push(this.newData)
            this.seriesData.push(this.newQuantity)
            this.options.push(this.newData)
            this.newData = ''
        }
    }

  }
</script>

<style scoped>
    .chartSize{
        height: 500px;
        width: 900px;
    }
    .inputSize{
        width: 200px;
    }
    .caption{
        margin-left: 18.75rem;
        margin-top: 2rem;
        color: rgb(100, 100, 100);
        font-size: 20px;
    }
</style>